import React from 'react';
import HostStore from "../../../stores/HostStore";
import DesignStore from "./../../../stores/DesignStore";
import * as SIP from 'sip.js'
import ContactDetail from "./ContactDetail";

class ContactSearch extends React.Component {

  constructor(props){
    super(props)
    this.state ={
      hosts: HostStore.loadHosts(),
      designs : DesignStore.getDesign(),
      selection: null
    }
    this.sip = null;
    this.updateHosts = this.updateHosts.bind(this);
    this.listHosts = this.listHosts.bind(this);
    this.selectHost = this.selectHost.bind(this);
  }

  selectHost(e, host){
    this.setState({
      selection : host
    });
  }

  componentDidMount (){
    DesignStore.on("design_loaded", this.update);
    HostStore.on("hosts_loaded", this.updateHosts);
  }

  update(){
    this.setState({
      designs : DesignStore.getDesign()
    })
  }

  updateHosts(){
    this.setState({
      hosts : HostStore.getHosts()
    })
  }

  listHosts(){
    return(
      <div className="main_view" id="contact_list">
          { this.state.hosts.map(function(host, index){
            let styles =[];
            if(this.state.designs){
              if( (index%2) !== 0){
                styles = {
                  backgroundColor: this.state.designs["main_color"],
                  color: "#fff"
                };
              }
            }

            return(
              <div className="singleHost" style={styles} key={ index } >
                <span onClick={(e) => this.selectHost(e, host)} className="host_infos" >{host.pe_name}, {host.pe_vorname}</span>
              </div>
          );
          }.bind(this)) }

      </div>
    )
  }

  showDetails(){
    if(this.state.selection){
      return(

        <div id="details">
          <div className="info">Name: {this.state.selection.pe_name}</div>
          <div className="info">Vorname: {this.state.selection.pe_vorname}</div>
          <div className="info">Abteilung: {this.state.selection.pe_department}</div>
          <div className="info">Raum: {this.state.selection.pe_room_nr}</div>
          <div className="info">Stockwerk: {this.state.selection.pe_floor}</div>
          <div className="info">Gebäude/Teil: {this.state.selection.pe_building} / {this.state.selection.pe_building_part}</div>
        </div>

      );
    }else{
      return(<div />);
    }
  }

  render() {

    let content = <div>Loading ... </div>;
    let details ="";

    if(this.state.hosts !== null && this.state.hosts !== undefined ){
      content = this.listHosts();
      details = this.showDetails();
    }

    return (
      <div id="ContactSearch" className="main_view">
        <h1>Kontakte</h1>
        {content}
        {details}
      </div>
    );
  }
}

export default ContactSearch;
