import React from 'react';
import Bye from "./Bye";
import CheckoutList from "./CheckoutList";
import CheckOutStore from "./../../../stores/CheckOutStore";

class CheckoutProzess extends React.Component {

  constructor(props){
    super(props)

    CheckOutStore.init(props.au.au_id);

    this.state = {
      ap : props.ap,
      au : props.au,
      checkout: CheckOutStore.getCheckOut(),
      status: CheckOutStore.getStatus()
    }
    this.update =  this.update.bind(this)
  }

  componentDidMount (){
    CheckOutStore.on("checkOut_changed", this.update);
    CheckOutStore.on("checkOut_loaded", this.update);
  }

  update(){
    this.setState({
      checkout : CheckOutStore.getCheckOut(),
      status : CheckOutStore.getStatus()
    })
  }

  render() {

    let step = null;

    if(this.state.checkout === null){
      step =  (<div>loading ...</div>)
    }else if(this.state.status === "bye" || this.state.status === "gone"){
      step =  (<Bye au={this.state.au} ap={this.state.ap} />)
    }else if(this.state.status === "checkOutlist" ){
      step =  (<CheckoutList checkin={this.state.checkout} />)
    }else {
      step =(<div>{this.state.status}</div>)
    }
    return (
      <div>{step}</div>
    );
  }
}

export default CheckoutProzess;
