import React from 'react';
import CheckinStore from "./../../../stores/CheckinStore";
import LanguageStore from "./../../../stores/LanguageStore";
import axios from 'axios';
import AppStore from "./../../../stores/AppStore";
import { properties } from '../../../properties.js';

class Sig extends React.Component {

  constructor(props){
    super(props)

    this.state ={
      sig:null,
      display : AppStore.getDisplay()
    }

    this.update =  this.update.bind(this)
    this.watch =  this.watch.bind(this)
    this.reset =  this.reset.bind(this)
    this.submit =  this.submit.bind(this)
    this.interval = null;
  }

  componentDidMount (){
    AppStore.load();
    AppStore.on("loaded", this.update);
  }

  update(){
    console.log(AppStore.getDisplay())
    this.setState({
      display : AppStore.getDisplay(),
    })
  }

  watch(){
    if(this.interval === null || this.interval === undefined ){
      this.interval = setInterval(function(){
        console.log(properties.api_url + "/hardware/sig/" + this.state.display.di_sig + "?SID=" + properties.key)
        axios.get(properties.api_url + "/hardware/sig/" + this.state.display.di_sig + "?SID=" + properties.key)
          .then(res => {

              this.setState({
               sig:res.data
             })

             clearInterval(this.interval);

          }).catch(function (error) {
             clearInterval(this.interval);
          })
      }.bind(this),1000);
    }
  }

  componentWillUnmount(){
    clearInterval(this.interval);
  }

  update(){
    this.setState({
      checklist : CheckinStore.getCheckInlist()
    })
  }

  reset(e){
    e.preventDefault();

    this.setState({
      sig: null
    })
    this.watch()
  }

  submit(e){
    e.preventDefault()
    if(this.interval){
      clearInterval(this.interval);
    }
    this.props.action(this.state.sig)
  }

  render() {

    if(this.state.sig === null){
      this.watch();
    }

    return (
      <div>
        { this.state.sig !== null ?(
          <div>
            <div className="sig">
              <img src={this.state.sig.web} alt="sig" />
            </div>
            <div>
              <input type="button" className="button" value="Wiederholen" onClick={this.reset} />
              <input type="button" className="button" value="OK" onClick={this.submit} />
            </div>
          </div>
        ):(
          <h2>{LanguageStore.translate("sig_pad_message")}</h2>
        )}

      </div>
    );
  }
}

export default Sig;
