import React from 'react';
import DesignStore from "./../../stores/DesignStore";
import LanguageStore from "./../../stores/LanguageStore";

class Brick extends React.Component {

  constructor(props) {
  super(props);
    this.state = {
      clickHandler : props.handler,
      icon : props.icon,
      desc : props.desc,
      button : props.button,
      title : props.title,
      link: props.link,
      designs : DesignStore.getDesign()
    };

    this.update = this.update.bind(this);
  }

  componentDidMount (){
    DesignStore.on("design_loaded", this.update);
    LanguageStore.on("language_loaded", this.update);
  }

  update(){
    this.setState({
      designs : DesignStore.getDesign()
    })
  }

  render() {

    let styles = null
    let buttonStyles = null
    if(this.state.designs){
      styles = {
        color: this.state.designs["main_font_color"],
        borderTopColor: this.state.designs["main_color"]
      };

      buttonStyles = {
        backgroundColor:this.state.designs["main_color"]
      };
    }

    return (
      <div style={styles} className="brick" onClick={(e) => this.state.clickHandler(e)}  data-link={this.state.link}>
        <img  alt="icon" className="icon" src={this.state.icon} onClick={(e) => this.state.clickHandler(e)}  data-link={this.state.link} />
        <div className="text">
          <span className="title" onClick={(e) => this.state.clickHandler(e)}  data-link={this.state.link}>{LanguageStore.translate(this.state.title)}</span>
          <span className="desc" onClick={(e) => this.state.clickHandler(e)}  data-link={this.state.link}>{LanguageStore.translate(this.state.desc)}</span>
        </div>
        <span style={buttonStyles} className="button" onClick={(e) => this.state.clickHandler(e)}  data-link={this.state.link}>
          {LanguageStore.translate(this.state.button)}
        </span>

      </div>
    );
  }
}

export default Brick;
