import React from 'react';
import { properties } from '../../properties.js';

class PDFElement extends React.Component {

  constructor(props) {
    super(props);

    this.state = {
      slider         : props.src,
      callback    : props.callback,
      interval    : props.interval,
      index : 0
    }

    this.intervalId  = 0;
    this.pages  = 0;

    this.startnterval = this.startnterval.bind(this);
    this.stopInterval = this.stopInterval.bind(this);
    this.handleSelect = this.handleSelect.bind(this);
 }

 componentDidMount() {
   this.startnterval();
  }

  componentWillUnmount (){
    this.stopInterval();
  }

  handleSelect(){
    if(this.props.src.parts.length > this.state.index + 1 ){
      this.setState({
        index:  this.state.index + 1
      });
    }else{
      this.stopInterval();
      this.state.index = 0;
      this.props.callback();
    }
  }

  stopInterval(){
    clearInterval(this.state.intervalId)
  }

  startnterval(){
    var intervalId = setInterval(this.handleSelect, this.state.interval);
    this.intervalId = intervalId;
  }

  render() {
    let part = this.props.src.parts[this.state.index];
    return ( <img src={part} /> )
  }

}

export default PDFElement;
