import dispatcher from "../Dispatcher";
import {EventEmitter} from "events";
import * as CheckinSelfActions from "../actions/CheckinSelfActions";
import axios from 'axios';
import { properties } from '../properties.js';

class CheckinSelfStore extends EventEmitter {

    constructor() {
        super();
        this.display = {
          categories:[]
        };
        this.load = this.load.bind(this);
        this.load();
    }

    handleActions(action) {
        switch (action.type) {
            case CheckinSelfActions.CHECKINSELF.CHANGED: {
              this.load();
              this.emit("checkinSelfStore_loaded");
              break;
            }
            case CheckinSelfActions.CHECKINSELF.CHECKIN:{
              console.log(action);
              break;
            }
            default: {
            }
        }
    }

    load(){
      axios.get(properties.api_url + "/visitor_category/?SID=" + properties.key)
        .then(res => {
          const categories = res.data;

          this.display = {
            categories : categories
          };
          this.emit("checkinSelfStore_loaded");

        }).catch(function (error) {
          console.log(error);
        })
    }

    getCheckinSelf() {
        return this.display;
    }

  checkIn(data){
    axios({
        method: 'post',
        url: properties.api_url + "/spontan_visitor/?SID=" + properties.key,
        data: JSON.stringify(data),
        config: { headers: {'Content-Type': 'multipart/form-data' }}
        })
      .then(res => {
        this.emit("visitor_registered");
      }).catch(function (error) {
        console.log(error);
      })
  }

}

const checkinSelfStore = new CheckinSelfStore();
dispatcher.register(checkinSelfStore.handleActions.bind(checkinSelfStore));
export default checkinSelfStore;
