import dispatcher from "../Dispatcher";
import {EventEmitter} from "events";
import axios from 'axios';
import { properties } from '../properties.js';

class DesignStore extends EventEmitter {

    constructor() {
        super();
        const queryString = require('query-string');
        const parsed = queryString.parse(window.location.search);
        this.di_id = parsed.di_id;
        this.design = [];
        this.load = this.load.bind(this);
        this.load();
        this.designs = null;
    }

    handleActions(action) {}

    getStyles(){
      return  properties.api_url + "/displaydesign/" + this.di_id + "/styles" + "?SID=" + properties.key;
    }

    load(){
      axios.get( properties.api_url + "/displaydesign/" + this.di_id + "?SID=" + properties.key )
        .then(res => {
          this.designs =  res.data;
          window.globals["design"] = res.data;
          this.emit("design_loaded");
        }).catch(function (error) {
          console.log(error);
        })
    }

    getDesign() {
        return this.designs;
    }
}

const designStore = new DesignStore();
dispatcher.register(designStore.handleActions.bind(designStore));
export default designStore;
