import dispatcher from "../Dispatcher";
import {EventEmitter} from "events";
import axios from 'axios';
import { properties } from '../properties.js';

class HostStore extends EventEmitter {

    constructor() {
        super();

        this.loadHosts = this.loadHosts.bind(this);
        this.getHosts = this.getHosts.bind(this);
        this.hosts = [];
    }

    getHosts(){
      return this.hosts;
    }

    loadHosts(){
      axios.get(properties.api_url + "/hosts/?SID=" + properties.key)
        .then(res => {
          let datas = res.data;
          this.hosts = datas;

          this.emit("hosts_loaded");

        }).catch(function (error) {
          console.log(error);
        })
    }

    handleActions(action) {}

}



const host = new HostStore();
dispatcher.register(host.handleActions.bind(host));
export default host;
