import languageDispatcher from "../Dispatcher";
import {EventEmitter} from "events";
import axios from 'axios';
import { properties } from '../properties.js';

class LanguageStore extends EventEmitter {

    constructor() {
        super();
        this.lang = "DE";
        this.localization = [];
        this.load = this.load.bind(this);
        this.load();
    }

    handleActions(action) {
      switch (action.type) {
          case "load_language": {
            this.lang = action.data;
            this.load();
            this.emit("language_loaded");
            break;
          }
          default: {}
      }
    }

    load(){
      axios.get(properties.api_url + "/language/" + this.lang + "?SID=" + properties.key)
        .then(res => {
          console.log("loading lang done")
          this.localization = res.data;
          this.emit("language_loaded");
        }).catch(function (error) {
          console.log(error);
        })
    }

    translate(key){
      if(this.localization)
        return this.localization[key]
    }

    getLocalization() {
        return this.localization;
    }

    getLanguage() {
        return this.lang;
    }
}

const languageStore = new LanguageStore();
languageDispatcher.register(languageStore.handleActions.bind(languageStore));
export default languageStore;
